'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.__esModule = true;
exports.default = createComponent;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _pick = require('../utils/pick');

var _pick2 = _interopRequireDefault(_pick);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var mapStateToProps = function mapStateToProps(state) {
  return _extends({}, state);
};

var mergeProps = function mergeProps(stateProps, dispatchProps, _ref) {
  var is = _ref.is;

  var clean = _objectWithoutProperties(_ref, ['is']);

  return _extends({}, clean, {
    grid: _extends({}, stateProps, {
      is: is
    })
  });
};

var gridShape = _react.PropTypes.shape({
  media: _react.PropTypes.object.isRequired,
  reference: _react.PropTypes.object.isRequired,
  is: _react.PropTypes.string
}).isRequired;

var elem = function elem(tag) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    _inherits(Elem, _Component);

    function Elem() {
      _classCallCheck(this, Elem);

      return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    Elem.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
      if (process.env.NODE_ENV !== 'production') {
        return true;
      }

      if (process.env.NODE_ENV === 'production') {
        return nextProps.grid.media.name !== this.props.grid.media.name || nextProps.grid.is !== this.props.grid.is;
      }
    };

    Elem.prototype.render = function render() {
      var _props = this.props;
      var grid = _props.grid;
      var children = _props.children;

      var clean = _objectWithoutProperties(_props, ['grid', 'children']);

      return _react2.default.createElement(
        'div',
        { style: (0, _pick2.default)(tag, grid) },
        _react.Children.map(children, function (child) {
          return (0, _react.cloneElement)(child, _extends({}, clean));
        })
      );
    };

    return Elem;
  }(_react.Component), _class.propTypes = {
    grid: gridShape
  }, _temp;
};

function createComponent(tag) {
  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(elem(tag));
}